#include <stdio.h>
#include <stdlib.h>

const int MAX_NUMBER = 1000;

void user_plays()
{
  int r = rand() % MAX_NUMBER;  /* On choisit un nombre aléatoire dans
                                   l'intervalle [0, n-1] */
  int player = -1;              /* Valeur choisie par le joueur */
  int min = 0;                  /* Plus grande valeur au dessus de laquelle se
                                   trouve la réponse */
  int max = MAX_NUMBER-1;       /* Plus petite valeur en dessous de laquelle se
                                   trouve la réponse */

  while (player != r)
  {
    printf("Quel nombre?          [%d, %d] \n", min, max);
    scanf("%d", &player);
    if (player > r)
    {
      printf("C'est moins\n");
      if (player < max)
      {
        max = player;
      }
    }
    else if (player < r)
    {
      printf("C'est plus\n");
      if (player > min)
      {
        min = player;
      }
    }
  }
  printf("C'est gagné\n");
}


void computer_plays()
{
  int player = -1;              /* Valeur choisie par l'ordinateur */
  int min = 0;                  /* Plus grande valeur au dessus de laquelle se
                                   trouve la réponse */
  int max = MAX_NUMBER - 1;     /* Plus petite valeur en dessous de laquelle se
                                   trouve la réponse */
  char c;                       /* Réponse de l'utilisateur */
  int nb_step = 0;              /* Nombre d'étapes avant de gagner */

  printf("Choisissez un nombre, appuyez sur Entrée quand vous êtes prêt.\n");
  getchar();
  while (1)
  {
    nb_step++;
    if (max < min)
    {
      printf("Il semblerait que vous trichiez ...");
      return;
    }
    player = (min + max) / 2;
    printf("Est-ce %d? (+,-,=)   [%d, %d] \n",player, min, max);
    scanf("%c", &c);
    if (c == '+')
    {
      min = player + 1;
    }
    else if (c == '-')
    {
      max = player-1;
    }
    else
    {
      printf("J'ai trouvé %d ! J'ai gagné en %d étape(s).\n", player, nb_step);
      return;
    }
    getchar();
  }
  printf("C'est gagné\n");
}

int main()
{
  computer_plays();
}
